"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = featureComponents;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var React = _interopRequireWildcard(require("react"));
var _reactIs = require("react-is");
var _lodash = require("lodash");
var _reactRedux = require("react-redux");
var _reselect = require("reselect");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _excluded = ["children"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function featureComponents(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
      getFeatures: function getFeatures(state) {
        return state ? state.features : {};
      },
      sortFeatures: function sortFeatures(features) {
        return Object.values(features);
      }
    }),
    getFeatures = _defaults.getFeatures,
    sortFeatures = _defaults.sortFeatures,
    getComponents = _defaults.getComponents;
  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });
  function mergeProps(_ref, dispatchProps, _ref2) {
    var features = _ref.features;
    var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
    var renderedComponents = [];
    features.forEach(function (feature, featureIndex) {
      var components = getComponents(feature);
      if (components == null) return;
      if (!Array.isArray(components)) components = [components];
      components.forEach(function (Comp, index) {
        var key = featureIndex + ':' + index;
        if ( /*#__PURE__*/React.isValidElement(Comp)) {
          renderedComponents.push( /*#__PURE__*/React.cloneElement(Comp, _objectSpread(_objectSpread({}, props), {}, {
            key: key
          })));
        } else if ((0, _reactIs.isValidElementType)(Comp)) {
          var FeatureComponent = Comp;
          renderedComponents.push( /*#__PURE__*/React.createElement(FeatureComponent, (0, _extends2["default"])({}, props, {
            key: key
          })));
        }
      });
    });
    return {
      children: children instanceof Function ? children(renderedComponents) : /*#__PURE__*/React.createElement(React.Fragment, null, renderedComponents)
    };
  }
  mergeProps.propTypes = {
    "features": _propTypes["default"].arrayOf(function () {
      return (typeof Feature === "function" ? _propTypes["default"].instanceOf(Feature).isRequired : _propTypes["default"].any.isRequired).apply(this, arguments);
    }).isRequired
  };
  var FeatureComponents = function FeatureComponents(_ref3) {
    var children = _ref3.children;
    return children;
  };
  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureComponents);
}
featureComponents.propTypes = {
  "getFeatures": _propTypes["default"].func,
  "sortFeatures": _propTypes["default"].func,
  "getComponents": _propTypes["default"].func.isRequired
};
module.exports = exports.default;