"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = featureContent;
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var React = _interopRequireWildcard(require("react"));
var _lodash = require("lodash");
var _reactRedux = require("react-redux");
var _reselect = require("reselect");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _excluded = ["children"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function featureContent(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
      getFeatures: function getFeatures(state) {
        return state ? state.features : {};
      },
      sortFeatures: function sortFeatures(features) {
        return Object.values(features);
      }
    }),
    getFeatures = _defaults.getFeatures,
    sortFeatures = _defaults.sortFeatures,
    getContent = _defaults.getContent;
  var mapStateToProps = (0, _reselect.createStructuredSelector)({
    features: (0, _reselect.createSelector)(getFeatures, sortFeatures)
  });
  function mergeProps(_ref, dispatchProps, _ref2) {
    var features = _ref.features;
    var children = _ref2.children,
      props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
    var content = [];
    features.forEach(function (feature, featureIndex) {
      var featureContent = getContent(feature);
      if (featureContent == null) return;
      if (typeof featureContent === 'function') featureContent = featureContent(props);
      if (!Array.isArray(featureContent)) featureContent = [featureContent];
      featureContent.forEach(function (item, index) {
        if ( /*#__PURE__*/React.isValidElement(item) && item.key == null) {
          item = /*#__PURE__*/React.cloneElement(item, {
            key: featureIndex + ':' + index
          });
        }
        content.push(item);
      });
    });
    return {
      children: children instanceof Function ? children(content) : /*#__PURE__*/React.createElement(React.Fragment, null, content)
    };
  }
  mergeProps.propTypes = {
    "features": _propTypes["default"].arrayOf(function () {
      return (typeof Feature === "function" ? _propTypes["default"].instanceOf(Feature).isRequired : _propTypes["default"].any.isRequired).apply(this, arguments);
    }).isRequired
  };
  var FeatureContent = function FeatureContent(_ref3) {
    var children = _ref3.children;
    return children;
  };
  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureContent);
}
featureContent.propTypes = {
  "getFeatures": _propTypes["default"].func,
  "sortFeatures": _propTypes["default"].func,
  "getContent": _propTypes["default"].func.isRequired
};
module.exports = exports.default;