"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.bpfrpt_proptype_Options = void 0;
exports["default"] = featureLoader;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var React = _interopRequireWildcard(require("react"));
var _reactRedux = require("react-redux");
var _reduxFeatures = require("redux-features");
var _reselect = require("reselect");
var _lodash = require("lodash");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var bpfrpt_proptype_Options = exports.bpfrpt_proptype_Options = {
  "getFeatures": _propTypes["default"].func,
  "getFeatureStates": _propTypes["default"].func,
  "featureId": _propTypes["default"].string.isRequired,
  "render": _propTypes["default"].func
};
function featureLoader(options) {
  var _defaults = (0, _lodash.defaults)({}, options, {
      getFeatures: function getFeatures(state) {
        return state ? state.features : undefined;
      },
      getFeatureStates: function getFeatureStates(state) {
        return state ? state.featureStates : undefined;
      }
    }),
    getFeatures = _defaults.getFeatures,
    getFeatureStates = _defaults.getFeatureStates,
    featureId = _defaults.featureId,
    render = _defaults.render;
  var mapStateToProps = (0, _reselect.createSelector)(getFeatures, getFeatureStates, function () {
    var features = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var featureStates = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    return {
      feature: features[featureId],
      featureState: featureStates[featureId]
    };
  });
  function mergeProps(_ref, _ref2, props) {
    var feature = _ref.feature,
      featureState = _ref.featureState;
    var dispatch = _ref2.dispatch;
    return {
      dispatch: dispatch,
      featureState: featureState,
      children: render ? render({
        feature: feature,
        featureState: featureState,
        props: props
      }) : null
    };
  }
  var FeatureLoader = /*#__PURE__*/function (_React$Component) {
    (0, _inherits2["default"])(FeatureLoader, _React$Component);
    var _super = _createSuper(FeatureLoader);
    function FeatureLoader(props) {
      var _this;
      (0, _classCallCheck2["default"])(this, FeatureLoader);
      _this = _super.call(this, props);
      var featureState = props.featureState,
        dispatch = props.dispatch;
      if (featureState === 'NOT_LOADED') dispatch((0, _reduxFeatures.loadFeature)(featureId));
      return _this;
    }
    (0, _createClass2["default"])(FeatureLoader, [{
      key: "render",
      value: function render() {
        return this.props.children;
      }
    }]);
    return FeatureLoader;
  }(React.Component);
  return (0, _reactRedux.connect)(mapStateToProps, null, mergeProps)(FeatureLoader);
}